import { system, world } from '@minecraft/server';

function cmd() {
    system.run(cmd);

    const players = [...world.getPlayers()];
    const horde_1 = world.getDimension('overworld')
        .getEntitiesAtBlockLocation({ x: -301, y: 63, z: 90 })
        .filter(e => e.typeId === 'kubo:npc_quest_spawner');

    const horde_2 = world.getDimension('overworld')
        .getEntitiesAtBlockLocation({ x: -339, y: 63, z: -19 })
        .filter(e => e.typeId === 'kubo:npc_quest_spawner');

    const horde_3 = world.getDimension('overworld')
        .getEntitiesAtBlockLocation({ x: -378, y: 71, z: -184 })
        .filter(e => e.typeId === 'kubo:npc_quest_spawner');

    const yujin_loc = world.getDimension('overworld')
        .getEntitiesAtBlockLocation({ x: -321, y: 65, z: -61 })
        .filter(e => e.typeId === 'kubo:yujin');

    const ryuji_loc = world.getDimension('overworld')
        .getEntitiesAtBlockLocation({ x: -296, y: 65, z: 26 })
        .filter(e => e.typeId === 'kubo:ryuji');


    players.forEach(player => {
        if (horde_1.length) {
            const horde_1Coords = { x: -301, z: 90 };
            const { x: currentPosX, z: currentPosZ } = player.location;
            const distance = Math.hypot(currentPosX - horde_1Coords.x, currentPosZ - horde_1Coords.z);
            const angle = Math.atan2(horde_1Coords.x - currentPosX, horde_1Coords.z - currentPosZ);
            const playerDirection = Math.atan2(player.getViewDirection().x, player.getViewDirection().z);
            let difference = (angle - playerDirection) * (180 / Math.PI);

            if (difference < -180) difference += 360;
            else if (difference > 180) difference -= 360;

            const compassAngle = Math.floor(difference);
            const colorDistance = distance <= 50 ? '§a' : distance <= 100 ? '§e' : '§c';
            const colorAngle = Math.abs(compassAngle) <= 50 ? '§a' : Math.abs(compassAngle) <= 100 ? '§e' : '§c';

            let actionbarText = '';
            if (distance >= 8) {
                if (compassAngle >= -180 && compassAngle <= -8) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction >>>`;
                } else if (compassAngle >= 8 && compassAngle <= 180) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction <<<`;
                } else if (Math.abs(compassAngle) <= 8) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away`;
                }
            } else {
                actionbarText = '§8|| §fDefeat the §cHusk§f §8||';
            }

            const command = `/titleraw @a[name=${player.name},hasitem={item=kubo:horde_location_1,location=slot.weapon.mainhand}] actionbar {"rawtext":[{"text":"${actionbarText}"}]}`;
            player.runCommandAsync(command);
        };

        if (horde_2.length) {
            const horde_2Coords = { x: -339, z: -19 };
            const { x: currentPosX, z: currentPosZ } = player.location;
            const distance = Math.hypot(currentPosX - horde_2Coords.x, currentPosZ - horde_2Coords.z);
            const angle = Math.atan2(horde_2Coords.x - currentPosX, horde_2Coords.z - currentPosZ);
            const playerDirection = Math.atan2(player.getViewDirection().x, player.getViewDirection().z);
            let difference = (angle - playerDirection) * (180 / Math.PI);

            if (difference < -180) difference += 360;
            else if (difference > 180) difference -= 360;

            const compassAngle = Math.floor(difference);
            const colorDistance = distance <= 50 ? '§a' : distance <= 100 ? '§e' : '§c';
            const colorAngle = Math.abs(compassAngle) <= 50 ? '§a' : Math.abs(compassAngle) <= 100 ? '§e' : '§c';

            let actionbarText = '';
            if (distance >= 8) {
                if (compassAngle >= -180 && compassAngle <= -8) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction >>>`;
                } else if (compassAngle >= 8 && compassAngle <= 180) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction <<<`;
                } else if (Math.abs(compassAngle) <= 8) {
                    actionbarText = `§cHorde§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away`;
                }
            } else {
                actionbarText = '§8|| §fDefeat the §cPillager§f §8||';
            }

            const command = `/titleraw @a[name=${player.name},hasitem={item=kubo:horde_location_2,location=slot.weapon.mainhand}] actionbar {"rawtext":[{"text":"${actionbarText}"}]}`;
            player.runCommandAsync(command);
        };

        if (horde_3.length) {
            const horde_3Coords = { x: -378, z: -184 };
            const { x: currentPosX, z: currentPosZ } = player.location;
            const distance = Math.hypot(currentPosX - horde_3Coords.x, currentPosZ - horde_3Coords.z);
            const angle = Math.atan2(horde_3Coords.x - currentPosX, horde_3Coords.z - currentPosZ);
            const playerDirection = Math.atan2(player.getViewDirection().x, player.getViewDirection().z);
            let difference = (angle - playerDirection) * (180 / Math.PI);

            if (difference < -180) difference += 360;
            else if (difference > 180) difference -= 360;

            const compassAngle = Math.floor(difference);
            const colorDistance = distance <= 50 ? '§a' : distance <= 100 ? '§e' : '§c';
            const colorAngle = Math.abs(compassAngle) <= 50 ? '§a' : Math.abs(compassAngle) <= 100 ? '§e' : '§c';

            let actionbarText = '';
            if (distance >= 8) {
                if (compassAngle >= -180 && compassAngle <= -8) {
                    actionbarText = `§6Brown Mushroom§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction >>>`;
                } else if (compassAngle >= 8 && compassAngle <= 180) {
                    actionbarText = `§6Brown Mushroom§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction <<<`;
                } else if (Math.abs(compassAngle) <= 8) {
                    actionbarText = `§6Brown Mushroom§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away`;
                }
            } else {
                actionbarText = '§8|| §fGather the §6Brown Mushroom§r §8||';
            }

            const command = `/titleraw @a[name=${player.name},hasitem={item=kubo:horde_location_3,location=slot.weapon.mainhand}] actionbar {"rawtext":[{"text":"${actionbarText}"}]}`;
            player.runCommandAsync(command);
        };

        if (yujin_loc.length) {
            const yujin_locCoords = { x: -321, z: -61 };
            const { x: currentPosX, z: currentPosZ } = player.location;
            const distance = Math.hypot(currentPosX - yujin_locCoords.x, currentPosZ - yujin_locCoords.z);
            const angle = Math.atan2(yujin_locCoords.x - currentPosX, yujin_locCoords.z - currentPosZ);
            const playerDirection = Math.atan2(player.getViewDirection().x, player.getViewDirection().z);
            let difference = (angle - playerDirection) * (180 / Math.PI);

            if (difference < -180) difference += 360;
            else if (difference > 180) difference -= 360;

            const compassAngle = Math.floor(difference);
            const colorDistance = distance <= 50 ? '§a' : distance <= 100 ? '§e' : '§c';
            const colorAngle = Math.abs(compassAngle) <= 50 ? '§a' : Math.abs(compassAngle) <= 100 ? '§e' : '§c';

            let actionbarText = '';
            if (distance >= 8) {
                if (compassAngle >= -180 && compassAngle <= -8) {
                    actionbarText = `§bYujin§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction >>>`;
                } else if (compassAngle >= 8 && compassAngle <= 180) {
                    actionbarText = `§bYujin§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction <<<`;
                } else if (Math.abs(compassAngle) <= 8) {
                    actionbarText = `§bYujin§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away`;
                }
            } else {
                actionbarText = '§8|| §fReports back to §bYujin§r §8||';
            }

            const command = `/titleraw @a[name=${player.name},hasitem={item=kubo:yujin_compass,location=slot.weapon.mainhand}] actionbar {"rawtext":[{"text":"${actionbarText}"}]}`;
            player.runCommandAsync(command);
        };

        if (ryuji_loc.length) {
            const ryuji_locCoords = { x: -296, z: 26 };
            const { x: currentPosX, z: currentPosZ } = player.location;
            const distance = Math.hypot(currentPosX - ryuji_locCoords.x, currentPosZ - ryuji_locCoords.z);
            const angle = Math.atan2(ryuji_locCoords.x - currentPosX, ryuji_locCoords.z - currentPosZ);
            const playerDirection = Math.atan2(player.getViewDirection().x, player.getViewDirection().z);
            let difference = (angle - playerDirection) * (180 / Math.PI);

            if (difference < -180) difference += 360;
            else if (difference > 180) difference -= 360;

            const compassAngle = Math.floor(difference);
            const colorDistance = distance <= 50 ? '§a' : distance <= 100 ? '§e' : '§c';
            const colorAngle = Math.abs(compassAngle) <= 50 ? '§a' : Math.abs(compassAngle) <= 100 ? '§e' : '§c';

            let actionbarText = '';
            if (distance >= 8) {
                if (compassAngle >= -180 && compassAngle <= -8) {
                    actionbarText = `§bRyuji§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction >>>`;
                } else if (compassAngle >= 8 && compassAngle <= 180) {
                    actionbarText = `§bRyuji§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away in ${colorAngle}${compassAngle}§f° direction <<<`;
                } else if (Math.abs(compassAngle) <= 8) {
                    actionbarText = `§bRyuji§f Location\n${colorDistance}${Math.floor(distance)}§f Blocks away`;
                }
            } else {
                actionbarText = '§8|| §fReports back to §bRyuji§r §8||';
            }

            const command = `/titleraw @a[name=${player.name},hasitem={item=kubo:ryuji_compass,location=slot.weapon.mainhand}] actionbar {"rawtext":[{"text":"${actionbarText}"}]}`;
            player.runCommandAsync(command);
        };

    });
};

cmd();